#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <assert.h>
#include <errno.h>

int
main(int argc, char **argv)
{
	int sockfd;
	struct sockaddr_in addr;
	char *msg = "HELO cs.tum.edu\n";
	int msgLen = strlen(msg);
	int written;


	sockfd = socket(PF_INET, SOCK_STREAM, 0);
	if (sockfd < 0) {
		perror("Can't create socket");
		exit(1);
	}
	printf("Client: created socket\n");


	memset (&addr, 0, sizeof(addr));
    addr.sin_family = AF_INET;
    addr.sin_port = htons(9999);
    addr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (connect(sockfd, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
		perror("Can't connect");
		exit(2);
	}
	printf("Client: connected to 0x%x:%d\n",
		   ntohl(addr.sin_addr.s_addr), ntohs(addr.sin_port));

	
	written = 0;
	while (written < msgLen) {
		int res = send(sockfd, &msg[written], msgLen-written, 0);
		if ((res < 0) && (errno != EINTR)) {
			perror("Can't write");
			exit(3);
		}
		if (res >= 0) {
			written += res;
		}
	}
	printf("Client: sent '%s'\n", msg);


	while (1) {
		char buf[80];
		int len = recv(sockfd, buf, 79, 0);
		if (len <= 0) {
			break;
		}
		assert(len < 80);
		buf[len] = '\0';
		printf("Client: received '%s'\n", buf);
	}

	close(sockfd);
	printf("Client: closed socket\n");

	exit(0);
}
