#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <unistd.h>
#include <assert.h>
#include <errno.h>
#include <string.h>

int
main(int argc, char **argv)
{
	int sockfd;
	struct sockaddr_in addr;
	char *msg = "Hello old friend!\n"
				"How are you?\n"
				"I am fine.\n"
				"I hope you are fine, too.\n"
				"If not, try to become fine again, soon.\n"
				"I really like talking to you.\n"
				"Do you still listen?\n";
	int msgLen = strlen(msg);
	int written;
	int connfd;
	struct sockaddr_in peerAddr;
	unsigned int peerAddrLen = sizeof(peerAddr);


	sockfd = socket(PF_INET, SOCK_STREAM, 0);
	if (sockfd < 0) {
		perror("Can't create socket");
		exit(1);
	}
	printf("Server: created socket\n");


	memset (&addr, 0, sizeof(addr));
    addr.sin_family = AF_INET;
    addr.sin_port = htons(9999);
    addr.sin_addr.s_addr = htonl(INADDR_ANY);

	if (bind(sockfd, (struct sockaddr *)&addr, sizeof(addr)) < 0) {
		perror("Can't bind");
		exit(2);
	}
	printf("Server: bound socket to 0x%x:%d\n",
		   ntohl(addr.sin_addr.s_addr), ntohs(addr.sin_port));


	if (listen(sockfd, 0) < 0) {
		perror("Can't listen");
		exit(3);
	}
	printf("Server: listening on socket\n");


	while (1) {
		connfd = accept(sockfd, (struct sockaddr *)&peerAddr, &peerAddrLen);
		if (connfd < 0) {
			perror("Can't accept");
			exit(4);
		}
		printf("Server: accept connection from 0x%x:%d\n",
		       ntohl(peerAddr.sin_addr.s_addr), 
			   ntohs(peerAddr.sin_port));
		
		while (1) {
			char buf[80];
			int len = recv(connfd, buf, 79, 0);
			if (len <= 0) {
				break;
			}
			assert(len < 80);
			buf[len] = '\0';
			printf("Server: received '%s'\n", buf);
			if (strchr(buf, '\n') != NULL) {
				break;
			}
		}
		

		written = 0;
		while (written < msgLen) {
			int res = send(connfd, &msg[written], msgLen-written, 0);
			if ((res < 0) && (errno != EINTR)) {
				perror("Can't write");
				exit(5);
			}
			if (res >= 0) {
				written += res;
			}
		}
		printf("Server: sent '%s'\n", msg);
		
		close(connfd);
		printf("Server: closed connection\n");
	}


	close(sockfd);
	exit(0);
}
